
turf
	minigame
		pong
			icon = 'STM_MP_board.dmi'
			icon_state= "black"
			name = "F_STM_Ping"
			var
				mob/Player1
				mob/Player2
				atom/movable/minigame_piece/paddle/P1
				atom/movable/minigame_piece/paddle/P2
				atom/movable/minigame_piece/ball/Ball
				started = FALSE
				atom/movable/minigame_piece/frame/F
				atom/movable/minigame_piece/score/S1
				atom/movable/minigame_piece/score/S2
				goal = 10

			verb
				BoardColor()
					set src in oview(1)
					set hidden = 1
					if(!(usr in list(Player1, Player2)))
						usr << "Only players may modify the board."
						return
					var/icon/I = new('STM_MP_board.dmi')
					var/list/L = I.IconStates()
					var/newcolor = input(usr, "Select a new board color.", "Board Color", icon_state) as null|anything in L
					if(newcolor)
						icon_state = newcolor
				FrameColor()
					set src in oview(1)
					set hidden = 1
					if(!(usr in list(Player1, Player2)) )
						usr << "Only players may modify the board."
						return
					var/icon/I = new('STM_MP_frame.dmi')
					var/list/L = I.IconStates()
					var/newcolor = input(usr, "Select a new frame color.", "Frame Color", icon_state) as null|anything in L
					if(newcolor)
						F.icon_state = newcolor


			proc
				NewRound()
					del Ball
					Ball = new(src)
					spawn(10)
						Ball.LifeCycle()

				Point(mob/M)
					if(M == Player1)
						if(S1.Add() >= goal)
							Winner(Player2)
						else
							NewRound()
					else
						if(S2.Add() >= goal)
							Winner(Player1)
						else
							NewRound()

				My_Paddle(mob/M)
					if(M == Player1)
						return P1
					return P2

				Score(value)
					if(value >=0)
						Point(Player2)
					else
						Point(Player1)


				Winner(mob/M)
					oviewers(src, 1) << "[M] has won the game."
					ohearers(src, 1) << 'applausesmall.wav'
					Reset()

				Reset()
					S1.Reset()
					S2.Reset()
					del Ball
					started = FALSE

				CheckForPaddle(xval, yval)
					var/offset = 0
					if(yval >=0)
						offset = P2.Offset(xval, yval)
					else
						offset = P1.Offset(xval, yval)
					return offset
				Start()
					Ball = new(src)
					started = TRUE
					oviewers(src,1) << "Game starting in two seconds..."
					spawn(20)
						Ball.LifeCycle()


			instructions()
				var/page ={"
<center><h2>Ping Instructions</h2></center>
<table align=center width=80%><tr><td>
To join the game, simply bump into the board from either
the north or the south.  Once the game has two players,
either player may press the center button, (or the 5 key
on the numpad), to begin the game.
<br><br>
Gameplay is simple.  Each player must move their paddle to
prevent the ball from crossing into their end of the game
board.  Move the paddle with the left or right arrow keys.
First player to 10 points wins the game.
<br><br>
To quit the game, press the 'esc' key.  If you quit once
a game has begun, your opponent wins and the game begins
anew.
<br><br>
Good Luck!
</td></tr></table>
"}
				usr << browse(page)


			GameBumped(mob/M)
				if((M.dir == NORTH) && !Player1)
					switch(alert(M, "Would you like to join this game?", "Join game?", "Yes", "No"))
						if("No") return
					Player1 = M
					M.client.Game = src
				else if((M.dir == SOUTH) && !Player2)
					switch(alert(M, "Would you like to join this game?", "Join game?", "Yes", "No"))
						if("No") return
					Player2 = M
					M.client.Game = src

				// M just bumped into this game
			PlayerInput(mob/M, Dir)
				/* mob just input Dir into this game.
					Dir 0 is the center numpad key. */
				if(Dir in list(EAST, WEST))
					var/atom/movable/minigame_piece/paddle/P = My_Paddle(M)
					P.AttemptMove(Dir)
				if(Dir == 0 && !started)
					if(Player1 && Player2)
						Start()
					else
						oview(src,1) << "Not enough players to start game."


			Quit(mob/M)
				// Called when M quit the game by using the esc key.
				if(M == Player1)
					if(Player2 && started) DefaultWinner(Player2)
					Player1 = null
				else
					if(Player1 && started)	DefaultWinner(Player1)
					Player2 = null

			New()
				..()
				P1 = new(src)
				P1.pixel_y = 3
				P2 = new(src)
				P2.pixel_y = 28
				F = new(src)
				S1 = new(src, NORTH)
				S2 = new(src, SOUTH)

			proc
				DefaultWinner(mob/M)
					oviewers(src,1) << "[M] wins the game by default"
					Reset()




atom/movable/minigame_piece
	/* Provided as a standard atom for game pieces so that a developer may
		limit their game's verbs from functioning on the game piece. More
		details are provided in the use.dm file. */
	paddle
		icon = 'STM_MP_paddle.dmi'
		icon_state = "Easy"
		name = "F_STM_Ping"
		var
			width = 11
			position = 14// based on the center of the paddle
		proc
			AttemptMove(Dir)
				switch(Dir)
					if(EAST)
						if(position < 22)
							position += 3
							pixel_x +=3
					if(WEST)
						if(position >6)
							position -= 3
							pixel_x -= 3

			Offset(xval, yval)
				xval += 14
				var/Left = position-round(width/2)
				var/Right = position+round(width/2)
				if((xval >= Left) && (xval <= Right))
					if(xval<=Left+2)
						return rand(23,32)*(yval/abs(yval))* (-1)
					else if(xval >= Right-2)
						return rand(23,32)*(yval/abs(yval))
					return 1
				return 0





	ball
		icon = 'STM_MP_ball.dmi'
		name = "F_STM_Ping"
		var
			speed = 4
			currentDirection
			turf/minigame/pong/Owner
		New(loc)
			Owner = loc
			currentDirection = pick(45,60,90,120,135,225,250,270,290,315)
		proc
			LifeCycle()
				if(pixel_x >= 14 || pixel_x <= -14)
					currentDirection = (540-currentDirection)%360
				else if(pixel_y >=12 || pixel_y <=-12)
					var/offset = Owner.CheckForPaddle(pixel_x, pixel_y)
					if(offset)
						world << "Playing blip"
						ohearers(Owner, 1) << 'blip.wav'
						currentDirection = 360-currentDirection + offset
					else
						ohearers(Owner, 1) << 'ploop.wav'
						Owner.Score(pixel_y)

				var/newX
				var/newY
				newY = round(speed*sin(currentDirection))
				newX = round(sqrt(speed*speed-newY*newY))
				if(currentDirection <=90 || currentDirection >=270)
					pixel_x = min(newX+pixel_x, 14)
				else
					pixel_x = max(pixel_x-newX, -14)
				pixel_y = max(min(pixel_y+newY, 12), -12)
				spawn(3)
					LifeCycle()

	frame
		icon = 'STM_MP_frame.dmi'
		icon_state = "blue"
		name = "F_STM_Ping"

	score
		name = "F_STM_Ping"
		var
			atom/movable/minigame_piece/number/Ones
			atom/movable/minigame_piece/number/Tens
			value = 0

		New(loc, value)
			Ones = new(loc,value)
			Tens = new(loc,value)
			Ones.pixel_x = -26
			Tens.pixel_x = -32
			..()

		proc
			Reset()
				value = 0
				Ones.icon_state = ""
				Tens.icon_state = ""

			Add()
				value += 1
				Update()
				return value

			Update()
				if(value >= 100) value = 99
				Ones.icon_state = "[value%10]"
				if(value > 9)
					Tens.icon_state = "[(value%100 - value%10)/10]"
				else
					Tens.icon_state = ""

	number
		name = "F_STM_Ping"
		icon = 'STM_MP_numbers.dmi'
		New(loc, value)
			..()
			if(value == NORTH)
				pixel_y = 32
			else
				pixel_y = -11



client
	Del()
		if(Game)
			Game.Quit(mob)
			Game = null
		..()
